SUBROUTINE CGS2(vntemp,V,k,j)
  use my_data         
  IMPLICIT NONE
  INTEGER k,j
  REAL ONE, ZERO, MINUSONE
  PARAMETER ( ONE = 1.0E+0, ZERO=0.0E+0,MINUSONE = -1.0E+0 )
  REAL V(k,j),vntemp(k)
  CALL SGEMV('T',k,j,ONE,V,k,vntemp,1,ZERO,WORK,1)
  CALL SGEMV('N',k,j,MINUSONE,V,k,WORK,1,ONE,vntemp,1)
  CALL SGEMV('T',k,j,ONE,V,k,vntemp,1,ZERO,WORK,1)
  CALL SGEMV('N',k,j,MINUSONE,V,k,WORK,1,ONE,vntemp,1)
END SUBROUTINE CGS2

SUBROUTINE MGS(V,WORK2)
  use my_data         
  IMPLICIT NONE
  INTEGER I,J
  REAL ONE, ZERO, MINUSONE
  PARAMETER ( ONE = 1.0E+0, ZERO=0.0E+0,MINUSONE = -1.0E+0 )
  REAL ALPHA,V(ncv,nsv),SDOT,WORK2(nsv)

  DO I=1,nsv
     ALPHA = SQRT(SDOT(ncv,V(1,I),1,V(1,I),1))
     DO J=1,ncv
        V(J,I) = V(J,I)/ALPHA
     ENDDO

     IF (I .LT. nsv) THEN
        CALL SGEMV('T',ncv,nsv-I,ONE,V(1,I+1),ncv,V(1,I),1,ZERO,WORK2,1)
        CALL SGER(ncv,nsv-I,MINUSONE,V(1,I),1,WORK2,1,V(1,I+1),ncv)
        CALL SGEMV('T',ncv,nsv-I,ONE,V(1,I+1),ncv,V(1,I),1,ZERO,WORK2,1)
        CALL SGER(ncv,nsv-I,MINUSONE,V(1,I),1,WORK2,1,V(1,I+1),ncv)
     ENDIF
  ENDDO

END SUBROUTINE MGS
